public class DatenGA implements IDatenGA {
 //max Masse = 75% der Gegenstandsmasse
 public DatenGA (int codelaenge){
     this.codelaenge = codelaenge;
     massen = new int[codelaenge];
     werte = new int[codelaenge];
     int massensumme=0;
     for (int k=0; k<codelaenge; k++){
       int m =  (int) (Math.random()*codelaenge)+1;
       massen[k] = m;
       massensumme +=m;
       int w =  (int) (Math.random()*codelaenge+1);
       werte[k] = w;
     }
     maxMasse = (int) (0.75 *massensumme);
 }
 //-------------- notwendige vom Interface geforderte Implementationen ---------
     public int fitnesswert(Individuum genCode){
        int wert = 0;
        int masse=0;
        for (int k=0; k<codelaenge; k++){
            if(genCode.getGen(k)==1){
            wert = wert + werte[k];
            masse = masse + massen[k];
          }
        }//for
        if (masse > maxMasse) {
          wert = 0;
        }
        return wert;
    }
    
    public boolean istBesser(Individuum c1, Individuum c2){
      return fitnesswert(c1) >= fitnesswert(c2);
    }
    
    public String toString(){
      String s = "";
      for (int k=0; k<codelaenge; k++){
          s=s+k+" Masse = "+massen[k]+" Wert = "+werte[k]+"\n";
      }
      s=s+"Maximale Masse = "+maxMasse+"\n";
      return s;
    }
    
    public Paar kreuzung( Individuum c1, Individuum c2){
      int codeLaenge = c1.getCodelnge();
      int stelle = (int) (Math.random()*codeLaenge)+1;
      Individuum i1 = new Individuum(codeLaenge);
      Individuum i2 = new Individuum(codeLaenge);
      for(int k = 0; k < stelle; k++) {
        i1.setGen(k, c1.getGen(k));
        i2.setGen(k, c2.getGen(k));
      }
      for(int k = stelle; k < codeLaenge; k++) {
        i1.setGen(k, c2.getGen(k));
        i2.setGen(k, c1.getGen(k));
      }
      return new Paar(i1,i2);
    }


    public void mutiere( Individuum c){
     int pos =  (int)( Math.random()*c.getCodelnge());
      if (c.getGen(pos) == 1) c.setGen(pos,0);
      else c.setGen(pos,1);
    }
    
    
    public void initZufllig(Individuum c){
       for (int j=0; j < c.getCodelnge(); j++) {
        if(Math.random()<0.5)
         c.setGen(j,1);
        else c.setGen(j,0);
       }
    }//initZufllig
 
 
 // -----------zustzliche Methoden zur exakten Auswertung ---------
 public int getMaxMasse(){
   return maxMasse;
 }
 
 public int getMasse(Individuum genCode){
        int masse=0;
        for (int k=0; k<codelaenge; k++){
            if(genCode.getGen(k)==1){
            masse = masse + massen[k];
          }
        }//for
        return masse;
    }
 //------------Attribute ------------------------------------------
    private int[] massen;
    private int[] werte;
    private int maxMasse;
    private int codelaenge;
}

