/* Generated by Together */

import java.util.*;

public class Population extends Observable{

    public Population(int anzahl, int cLaenge, int mRate, IDatenGA grunddaten) {

        populationsGroesse = anzahl;

        population = new Individuum[anzahl];

        mutationsrate= mRate;

        codeLaenge= cLaenge;

        this.grunddaten = grunddaten;

        belegeZufaellig();

    }



    public void belegeZufaellig(){

      for (int k=0; k < populationsGroesse; k++){

       Individuum code = new Individuum(codeLaenge);

       grunddaten.initZufllig(code);

       population[k] = code;

      }

      setChanged(); notifyObservers();

    }





    public int getPopulationsGroesse(){ return populationsGroesse; }



    public IDatenGA getGrunddaten(){ return grunddaten; }



    public int getCodeLaenge(){ return codeLaenge; }



    public void setMutationsrate(int m){ mutationsrate = m; }

    public int getMutationsrate(){ return mutationsrate; }



    public Individuum getIndividuum(int nr){ return population[nr];}

    public void setIndividuum(int nr, Individuum iv){population[nr]=iv;}





    public void naechsteGeneration() {

      Individuum[] naechsteGen = new Individuum[populationsGroesse];

      for (int k=0; k < populationsGroesse; k=k+2){

         Individuum i1 = liesZufllig();

         Individuum i2 = liesZufllig();

         Paar p = grunddaten.kreuzung(i1,i2);

         naechsteGen[k] = p.getErstes();         // 1. Kind

         int zufall = (int) (Math.random()*100);

         if (zufall <= mutationsrate) 

           grunddaten.mutiere(naechsteGen[k]);

         if (k+1 < populationsGroesse){

          naechsteGen[k+1] = p.getZweites();      // 2. Kind

          zufall = (int) (Math.random()*100);

          if (zufall <= mutationsrate) 

           grunddaten.mutiere(naechsteGen[k+1]);

           }

      }

      population = naechsteGen;

      setChanged(); notifyObservers();

    }



    public Individuum bestes() {

        int nr=0;

        int max = grunddaten.fitnesswert(population[nr]);

        Individuum bestesgeneration = population[nr];

        for (int k=1; k < populationsGroesse; k++){

           int wert = grunddaten.fitnesswert(population[k]);

           if (grunddaten.istBesser(population[k],population[nr])) {

              max = wert;

              nr = k;

              bestesgeneration = population[k];

           }

        }

        return bestesgeneration;

    }

  // vvvvvvvvvvvvvvvvvvv private vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv





    private Individuum liesZufllig() {

        int nr1 = (int) (Math.random()*populationsGroesse);

        int nr2 = (int) (Math.random()*populationsGroesse);

        //if (grunddaten.fitnesswert(individuum[nr1]) > grunddaten.fitnesswert(individuum[nr2]))

        if(grunddaten.istBesser(population[nr1],population[nr2]))

            return population[nr1];

        else return population[nr2];

    }







    private int populationsGroesse;

    private static int codeLaenge;

    private int mutationsrate;

    private Individuum[] population;

    private IDatenGA grunddaten;

    private Paar p;



    public static void main (String[] arg){

      DatenGA grunddaten = new DatenGA(codeLaenge);

      Population p= new Population(10,12,2,grunddaten);

      for ( int i=0 ;i<p.getPopulationsGroesse()  ;i++  ) {

        Individuum c = p.getIndividuum(i);

        System.out.print(c);

        System.out.println("  "+ grunddaten.fitnesswert(c));

      }

    }



  }

